function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useContext, useMemo, useState } from 'react';
import { AlertsContextProvider } from '../../alert';
import Form from './Form';
const DisplayErrorCtx = /*#__PURE__*/React.createContext(false);
const CustomForm = ({
  ...props
}, ref) => {
  const [displayError, setDisplayError] = useState(false);
  const {
    formFields,
    setFormFields
  } = props;
  const context = useMemo(() => ({
    displayError,
    setDisplayError,
    formFields,
    setFormFields,
    setFormField: (fieldName, value) => setFormFields(prev => ({
      ...prev,
      [fieldName]: value
    }))
  }), [displayError, formFields]);
  return /*#__PURE__*/React.createElement(AlertsContextProvider, null, /*#__PURE__*/React.createElement(DisplayErrorCtx.Provider, {
    value: context
  }, /*#__PURE__*/React.createElement(Form, _extends({}, props, {
    ref: ref
  }))));
};
const useFormContext = () => useContext(DisplayErrorCtx);
export { DisplayErrorCtx, useFormContext };
export default /*#__PURE__*/React.forwardRef(CustomForm);