function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useState } from 'react';
import { useAlertsContext } from '../../alert';
import { useFormContext } from './CustomForm';
const Form = ({
  children,
  formFields = {},
  setFormFields = () => {},
  onSubmit = () => {},
  submitLabel = 'Valider',
  cancelLabel = 'Annuler',
  className = '',
  disabled = false,
  isLoading = false,
  onCancel = null,
  errorMessage = null,
  isFormValid = true,
  hideValidateButton = false,
  alertErrorMessage = 'Une erreur est survenue',
  ...props
}, ref) => {
  const {
    displayError,
    setDisplayError
  } = useFormContext();
  const [isLoadingSubmit, setIsLoadingSubmit] = useState(false);
  const {
    addAlert
  } = useAlertsContext();
  const submit = e => {
    e.preventDefault();
    !displayError && setDisplayError(true);
    if (isFormValid) {
      setIsLoadingSubmit(true);
      Promise.resolve(onSubmit(e)).catch(e => (addAlert(alertErrorMessage, 'danger'), console.log(e.config.data))).finally(() => setIsLoadingSubmit(false));
    }
  };
  return /*#__PURE__*/React.createElement("form", _extends({
    onSubmit: submit,
    className: className
  }, props, {
    ref: ref
  }), children, displayError && !isFormValid && errorMessage != null && /*#__PURE__*/React.createElement("p", {
    className: "informations danger"
  }, errorMessage), /*#__PURE__*/React.createElement("div", {
    className: "form-buttons-container"
  }, !hideValidateButton && /*#__PURE__*/React.createElement("button", {
    disabled: disabled || isLoading,
    className: `button button-uca-blue spaced-inline ${(disabled || isLoading) && 'disabled'}`
  }, /*#__PURE__*/React.createElement("span", null, submitLabel), isLoading || isLoadingSubmit && /*#__PURE__*/React.createElement("div", {
    className: "spinner-border spinner-border-sm",
    role: "status"
  })), onCancel != null && /*#__PURE__*/React.createElement("button", {
    className: "button button-uca-beige",
    type: "button",
    onClick: onCancel
  }, cancelLabel)));
};
export default /*#__PURE__*/React.forwardRef(Form);